image: docker:stable
services:
  - docker:dind
variables:
  DOCKER_DRIVER: overlay2

stages:
  - build
  - release

before_script:
  - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY

build_kubeci:
  stage: build
  script:
    - >
      docker build
      --pull
      --cache-from $CI_REGISTRY_IMAGE:latest
      --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
      .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  only:
    - master

build_runner:
  stage: build
  script:
    - >
      cd runner &&
      docker build
      --pull
      --cache-from ${CI_REGISTRY_IMAGE}/runner:latest
      --tag ${CI_REGISTRY_IMAGE}/runner:${CI_COMMIT_REF_SLUG}
      .
    - docker push $CI_REGISTRY_IMAGE/runner:$CI_COMMIT_REF_SLUG
  only:
    - master


push_kubeci:
  stage: release
  variables:
    GIT_STRATEGY: none
  script:
    - docker pull $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG $CI_REGISTRY_IMAGE:${CI_COMMIT_TAG:-latest}
    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:${CI_COMMIT_TAG:-latest}
    - docker push $CI_REGISTRY_IMAGE:latest
  only:
    - master

push_runner:
  stage: release
  variables:
    GIT_STRATEGY: none
  script:
    - docker pull $CI_REGISTRY_IMAGE/runner:$CI_COMMIT_REF_SLUG
    - docker tag $CI_REGISTRY_IMAGE/runner:$CI_COMMIT_REF_SLUG $CI_REGISTRY_IMAGE/runner:${CI_COMMIT_TAG:-latest}
    - docker tag $CI_REGISTRY_IMAGE/runner:$CI_COMMIT_REF_SLUG $CI_REGISTRY_IMAGE/runner:latest
    - docker push $CI_REGISTRY_IMAGE/runner:${CI_COMMIT_TAG:-latest}
    - docker push $CI_REGISTRY_IMAGE/runner:latest
  only:
    - master